diff --git a/libglusterfs/src/glusterfs/async.h b/libglusterfs/src/glusterfs/async.h
index d1d70ae0bc7..1b507a9d695 100644
--- a/libglusterfs/src/glusterfs/async.h
+++ b/libglusterfs/src/glusterfs/async.h
@@ -43,7 +43,9 @@
  * be added to differentiate them. */
 #define GF_ASYNC_THREAD_NAME "tpw"
 
-/* This value determines the maximum number of threads that are allowed. */
+/* Threading parameters for async framework. */
+#define GF_ASYNC_MIN_THREADS 1
+#define GF_ASYNC_DEFAULT_THREADS 16
 #define GF_ASYNC_MAX_THREADS 128
 
 /* This value determines how many additional threads will be started but will
diff --git a/libglusterfs/src/glusterfs/common-utils.h b/libglusterfs/src/glusterfs/common-utils.h
index 71ccb23382e..a4175f5abc0 100644
--- a/libglusterfs/src/glusterfs/common-utils.h
+++ b/libglusterfs/src/glusterfs/common-utils.h
@@ -125,12 +125,21 @@ trap(void);
 #define GF_MS_IN_NS 1000000
 #define GF_US_IN_NS 1000
 
-/* Default timeout for both barrier and changelog translator */
-#define BARRIER_TIMEOUT "120"
+/* Default timeout for both barrier and changelog translator, in seconds. */
+#define BARRIER_TIMEOUT 120
 
-/* Default value of signing waiting time to sign a file for bitrot */
-#define SIGNING_TIMEOUT "120"
-#define BR_WORKERS "4"
+/* Default signing waiting time to sign a file for bitrot, in seconds. */
+#define SIGNING_TIMEOUT 120
+
+/* Threading parameters for bitrot. */
+#define BR_MIN_THREADS 1
+#define BR_MAX_THREADS 16
+#define BR_DEFAULT_THREADS 4
+
+/* Threading parameters for parallel heal, both for AFR and EC xlators. */
+#define SHD_MIN_THREADS 1
+#define SHD_MAX_THREADS 64
+#define SHD_DEFAULT_THREADS SHD_MIN_THREADS
 
 /* xxhash */
 #define GF_XXH64_DIGEST_LENGTH 8
diff --git a/xlators/cluster/afr/src/afr.c b/xlators/cluster/afr/src/afr.c
index 96c6fd6c9d2..6aec31425b4 100644
--- a/xlators/cluster/afr/src/afr.c
+++ b/xlators/cluster/afr/src/afr.c
@@ -1238,9 +1238,9 @@ struct volume_options options[] = {
     },
     {.key = {"shd-max-threads"},
      .type = GF_OPTION_TYPE_INT,
-     .min = 1,
-     .max = 64,
-     .default_value = "1",
+     .min = SHD_MIN_THREADS,
+     .max = SHD_MAX_THREADS,
+     .default_value = TOSTRING(SHD_DEFAULT_THREADS),
      .op_version = {GD_OP_VERSION_3_7_12},
      .flags = OPT_FLAG_CLIENT_OPT | OPT_FLAG_SETTABLE | OPT_FLAG_DOC,
      .tags = {"replicate"},
diff --git a/xlators/cluster/ec/src/ec.c b/xlators/cluster/ec/src/ec.c
index cfd574ed825..15b279b88a9 100644
--- a/xlators/cluster/ec/src/ec.c
+++ b/xlators/cluster/ec/src/ec.c
@@ -1761,9 +1761,9 @@ struct volume_options options[] = {
     },
     {.key = {"shd-max-threads"},
      .type = GF_OPTION_TYPE_INT,
-     .min = 1,
-     .max = 64,
-     .default_value = "1",
+     .min = SHD_MIN_THREADS,
+     .max = SHD_MAX_THREADS,
+     .default_value = TOSTRING(SHD_DEFAULT_THREADS),
      .op_version = {GD_OP_VERSION_3_9_0},
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC,
      .tags = {"disperse"},
diff --git a/xlators/debug/io-stats/src/io-stats.c b/xlators/debug/io-stats/src/io-stats.c
index 4c0f69ed570..38a6231cc2c 100644
--- a/xlators/debug/io-stats/src/io-stats.c
+++ b/xlators/debug/io-stats/src/io-stats.c
@@ -4449,8 +4449,8 @@ struct volume_options options[] = {
     {.key = {"threads"}, .type = GF_OPTION_TYPE_INT},
     {.key = {"brick-threads"},
      .type = GF_OPTION_TYPE_INT,
-     .default_value = "16",
-     .min = 0,
+     .default_value = TOSTRING(GF_ASYNC_DEFAULT_THREADS),
+     .min = GF_ASYNC_MIN_THREADS,
      .max = GF_ASYNC_MAX_THREADS,
      .op_version = {GD_OP_VERSION_6_0},
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC,
@@ -4459,8 +4459,8 @@ struct volume_options options[] = {
                     "maximum amount of threads that can be created on bricks"},
     {.key = {"client-threads"},
      .type = GF_OPTION_TYPE_INT,
-     .default_value = "16",
-     .min = 0,
+     .default_value = TOSTRING(GF_ASYNC_DEFAULT_THREADS),
+     .min = GF_ASYNC_MIN_THREADS,
      .max = GF_ASYNC_MAX_THREADS,
      .op_version = {GD_OP_VERSION_6_0},
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC | OPT_FLAG_CLIENT_OPT,
diff --git a/xlators/features/barrier/src/barrier.c b/xlators/features/barrier/src/barrier.c
index 905c21d579f..5e42d9b3f08 100644
--- a/xlators/features/barrier/src/barrier.c
+++ b/xlators/features/barrier/src/barrier.c
@@ -783,7 +783,7 @@ struct volume_options options[] = {
                     "default."},
     {.key = {"barrier-timeout"},
      .type = GF_OPTION_TYPE_TIME,
-     .default_value = BARRIER_TIMEOUT,
+     .default_value = TOSTRING(BARRIER_TIMEOUT),
      .op_version = {GD_OP_VERSION_3_6_0},
      .flags = OPT_FLAG_SETTABLE,
      .description = "After 'timeout' seconds since the time 'barrier' "
diff --git a/xlators/features/bit-rot/src/bitd/bit-rot.c b/xlators/features/bit-rot/src/bitd/bit-rot.c
index da435b22707..8bd4bbc9b61 100644
--- a/xlators/features/bit-rot/src/bitd/bit-rot.c
+++ b/xlators/features/bit-rot/src/bitd/bit-rot.c
@@ -2154,7 +2154,7 @@ struct volume_options options[] = {
     {
         .key = {"expiry-time"},
         .type = GF_OPTION_TYPE_INT,
-        .default_value = SIGNING_TIMEOUT,
+        .default_value = TOSTRING(SIGNING_TIMEOUT),
         .op_version = {GD_OP_VERSION_3_7_0},
         .flags = OPT_FLAG_SETTABLE,
         .description = "Waiting time for an object on which it waits "
@@ -2204,7 +2204,7 @@ struct volume_options options[] = {
     {
         .key = {"signer-threads"},
         .type = GF_OPTION_TYPE_INT,
-        .default_value = BR_WORKERS,
+        .default_value = TOSTRING(BR_DEFAULT_THREADS),
         .op_version = {GD_OP_VERSION_8_0},
         .flags = OPT_FLAG_SETTABLE,
         .description = "Number of signing process threads. As a best "
diff --git a/xlators/features/changelog/src/changelog.c b/xlators/features/changelog/src/changelog.c
index 50c1d2131c4..43ceb977f90 100644
--- a/xlators/features/changelog/src/changelog.c
+++ b/xlators/features/changelog/src/changelog.c
@@ -2954,7 +2954,7 @@ struct volume_options options[] = {
      .tags = {"journal"}},
     {.key = {"changelog-barrier-timeout"},
      .type = GF_OPTION_TYPE_TIME,
-     .default_value = BARRIER_TIMEOUT,
+     .default_value = TOSTRING(BARRIER_TIMEOUT),
      .description = "After 'timeout' seconds since the time 'barrier' "
                     "option was set to \"on\", unlink/rmdir/rename  "
                     "operations are no longer blocked and previously "
diff --git a/xlators/mgmt/glusterd/src/glusterd-volume-set.c b/xlators/mgmt/glusterd/src/glusterd-volume-set.c
index be3085ec503..b7ec75b912d 100644
--- a/xlators/mgmt/glusterd/src/glusterd-volume-set.c
+++ b/xlators/mgmt/glusterd/src/glusterd-volume-set.c
@@ -2485,7 +2485,7 @@ struct volopt_map_entry glusterd_volopt_map[] = {
     {
         .key = "changelog.changelog-barrier-timeout",
         .voltype = "features/changelog",
-        .value = BARRIER_TIMEOUT,
+        .value = TOSTRING(BARRIER_TIMEOUT),
         .op_version = GD_OP_VERSION_3_6_0,
     },
     {.key = "changelog.capture-del-path",
@@ -2502,7 +2502,7 @@ struct volopt_map_entry glusterd_volopt_map[] = {
     {
         .key = "features.barrier-timeout",
         .voltype = "features/barrier",
-        .value = BARRIER_TIMEOUT,
+        .value = TOSTRING(BARRIER_TIMEOUT),
         .op_version = GD_OP_VERSION_3_6_0,
     },
     {
@@ -2646,7 +2646,7 @@ struct volopt_map_entry glusterd_volopt_map[] = {
     {
         .key = "features.expiry-time",
         .voltype = "features/bit-rot",
-        .value = SIGNING_TIMEOUT,
+        .value = TOSTRING(SIGNING_TIMEOUT),
         .option = "expiry-time",
         .op_version = GD_OP_VERSION_3_7_0,
         .type = NO_DOC,
@@ -2654,7 +2654,7 @@ struct volopt_map_entry glusterd_volopt_map[] = {
     {
         .key = "features.signer-threads",
         .voltype = "features/bit-rot",
-        .value = BR_WORKERS,
+        .value = TOSTRING(BR_DEFAULT_THREADS),
         .option = "signer-threads",
         .op_version = GD_OP_VERSION_8_0,
         .type = NO_DOC,
diff --git a/xlators/mgmt/glusterd/src/glusterd.c b/xlators/mgmt/glusterd/src/glusterd.c
index 1185d7e1d20..617eba70fbf 100644
--- a/xlators/mgmt/glusterd/src/glusterd.c
+++ b/xlators/mgmt/glusterd/src/glusterd.c
@@ -2295,9 +2295,9 @@ struct volume_options options[] = {
     },
     {.key = {"event-threads"},
      .type = GF_OPTION_TYPE_INT,
-     .min = 1,
-     .max = 32,
-     .default_value = "2",
+     .min = GLUSTERD_MIN_EVENT_THREADS,
+     .max = GLUSTERD_MAX_EVENT_THREADS,
+     .default_value = TOSTRING(STARTING_EVENT_THREADS),
      .description = "Specifies the number of event threads to execute "
                     "in parallel. Larger values would help process"
                     " responses faster, depending on available processing"
diff --git a/xlators/mgmt/glusterd/src/glusterd.h b/xlators/mgmt/glusterd/src/glusterd.h
index 2b4c2a570cf..3e0eb89ea39 100644
--- a/xlators/mgmt/glusterd/src/glusterd.h
+++ b/xlators/mgmt/glusterd/src/glusterd.h
@@ -41,6 +41,10 @@
 
 #include "gd-common-utils.h"
 
+/* Threading limits for glusterd event threads. */
+#define GLUSTERD_MIN_EVENT_THREADS 1
+#define GLUSTERD_MAX_EVENT_THREADS 32
+
 #define GLUSTERD_TR_LOG_SIZE 50
 #define GLUSTERD_QUORUM_TYPE_KEY "cluster.server-quorum-type"
 #define GLUSTERD_QUORUM_RATIO_KEY "cluster.server-quorum-ratio"
diff --git a/xlators/nfs/server/src/nfs.c b/xlators/nfs/server/src/nfs.c
index fc80898294e..3eb644dc590 100644
--- a/xlators/nfs/server/src/nfs.c
+++ b/xlators/nfs/server/src/nfs.c
@@ -2068,9 +2068,9 @@ struct volume_options options[] = {
     {
         .key = {"nfs.event-threads"},
         .type = GF_OPTION_TYPE_SIZET,
-        .min = 1,
-        .max = 32,
-        .default_value = "2",
+        .min = NFS_MIN_EVENT_THREADS,
+        .max = NFS_MAX_EVENT_THREADS,
+        .default_value = TOSTRING(STARTING_EVENT_THREADS),
         .description = "Specifies the number of event threads to execute in"
                        "in parallel. Larger values would help process"
                        " responses faster, depending on available processing"
diff --git a/xlators/nfs/server/src/nfs.h b/xlators/nfs/server/src/nfs.h
index 46744ddaa40..b597871f277 100644
--- a/xlators/nfs/server/src/nfs.h
+++ b/xlators/nfs/server/src/nfs.h
@@ -23,8 +23,9 @@
 
 #define GF_NFS_INODE_LRU_MULT 6000
 
-#define GF_RPC_MIN_THREADS 1
-#define GF_RPC_MAX_THREADS 16
+/* Threading limits for nfs xlator event threads. */
+#define NFS_MIN_EVENT_THREADS 1
+#define NFS_MAX_EVENT_THREADS 32
 
 #define GF_NFS_DEFAULT_MEMFACTOR 15
 #define GF_NFS_MIN_MEMFACTOR 1
diff --git a/xlators/performance/io-threads/src/io-threads.c b/xlators/performance/io-threads/src/io-threads.c
index f7fa39a9914..a9475b9f428 100644
--- a/xlators/performance/io-threads/src/io-threads.c
+++ b/xlators/performance/io-threads/src/io-threads.c
@@ -1477,7 +1477,7 @@ struct volume_options options[] = {
      .type = GF_OPTION_TYPE_INT,
      .min = IOT_MIN_THREADS,
      .max = IOT_MAX_THREADS,
-     .default_value = "16",
+     .default_value = TOSTRING(IOT_DEFAULT_THREADS),
      .op_version = {1},
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC,
      .tags = {"io-threads"},
@@ -1490,7 +1490,7 @@ struct volume_options options[] = {
      .type = GF_OPTION_TYPE_INT,
      .min = IOT_MIN_THREADS,
      .max = IOT_MAX_THREADS,
-     .default_value = "16",
+     .default_value = TOSTRING(IOT_DEFAULT_THREADS),
      .op_version = {1},
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC,
      .tags = {"io-threads"},
@@ -1502,7 +1502,7 @@ struct volume_options options[] = {
      .type = GF_OPTION_TYPE_INT,
      .min = IOT_MIN_THREADS,
      .max = IOT_MAX_THREADS,
-     .default_value = "16",
+     .default_value = TOSTRING(IOT_DEFAULT_THREADS),
      .op_version = {1},
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC,
      .tags = {"io-threads"},
@@ -1514,7 +1514,7 @@ struct volume_options options[] = {
      .type = GF_OPTION_TYPE_INT,
      .min = IOT_MIN_THREADS,
      .max = IOT_MAX_THREADS,
-     .default_value = "16",
+     .default_value = TOSTRING(IOT_DEFAULT_THREADS),
      .op_version = {1},
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC,
      .tags = {"io-threads"},
@@ -1526,7 +1526,7 @@ struct volume_options options[] = {
      .type = GF_OPTION_TYPE_INT,
      .min = IOT_MIN_THREADS,
      .max = IOT_MAX_THREADS,
-     .default_value = "1",
+     .default_value = TOSTRING(IOT_MIN_THREADS),
      .op_version = {1},
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC,
      .tags = {"io-threads"},
diff --git a/xlators/protocol/client/src/client.c b/xlators/protocol/client/src/client.c
index 40d28e39077..9451dc21842 100644
--- a/xlators/protocol/client/src/client.c
+++ b/xlators/protocol/client/src/client.c
@@ -2969,9 +2969,9 @@ struct volume_options options[] = {
      .flags = OPT_FLAG_SETTABLE},
     {.key = {"event-threads"},
      .type = GF_OPTION_TYPE_INT,
-     .min = 1,
-     .max = 32,
-     .default_value = "2",
+     .min = CLIENT_MIN_EVENT_THREADS,
+     .max = CLIENT_MAX_EVENT_THREADS,
+     .default_value = TOSTRING(STARTING_EVENT_THREADS),
      .description = "Specifies the number of event threads to execute "
                     "in parallel. Larger values would help process"
                     " responses faster, depending on available processing"
diff --git a/xlators/protocol/client/src/client.h b/xlators/protocol/client/src/client.h
index 55ea59a6682..abe1b0c6b5e 100644
--- a/xlators/protocol/client/src/client.h
+++ b/xlators/protocol/client/src/client.h
@@ -26,6 +26,10 @@
 #include <glusterfs/default-args.h>
 #include "client-messages.h"
 
+/* Threading limits for client event threads. */
+#define CLIENT_MIN_EVENT_THREADS 1
+#define CLIENT_MAX_EVENT_THREADS 32
+
 /* FIXME: Needs to be defined in a common file */
 #define CLIENT_DUMP_LOCKS "trusted.glusterfs.clientlk-dump"
 #define GF_MAX_SOCKET_WINDOW_SIZE (1 * GF_UNIT_MB)
diff --git a/xlators/protocol/server/src/server.c b/xlators/protocol/server/src/server.c
index 30acc9bf939..140a0ac388b 100644
--- a/xlators/protocol/server/src/server.c
+++ b/xlators/protocol/server/src/server.c
@@ -1928,9 +1928,9 @@ struct volume_options server_options[] = {
      .flags = OPT_FLAG_SETTABLE | OPT_FLAG_DOC},
     {.key = {"event-threads"},
      .type = GF_OPTION_TYPE_INT,
-     .min = 1,
-     .max = 1024,
-     .default_value = "2",
+     .min = SERVER_MIN_EVENT_THREADS,
+     .max = SERVER_MAX_EVENT_THREADS,
+     .default_value = TOSTRING(STARTING_EVENT_THREADS),
      .description = "Specifies the number of event threads to execute "
                     "in parallel. Larger values would help process"
                     " responses faster, depending on available processing"
diff --git a/xlators/protocol/server/src/server.h b/xlators/protocol/server/src/server.h
index 820d3b3c3f1..4bc05de8ac6 100644
--- a/xlators/protocol/server/src/server.h
+++ b/xlators/protocol/server/src/server.h
@@ -26,6 +26,10 @@
 #include <glusterfs/defaults.h>
 #include "authenticate.h"
 
+/* Threading limits for server event threads. */
+#define SERVER_MIN_EVENT_THREADS 1
+#define SERVER_MAX_EVENT_THREADS 1024
+
 #define DEFAULT_VOLUME_FILE_PATH CONFDIR "/glusterfs.vol"
 #define GF_MAX_SOCKET_WINDOW_SIZE (1 * GF_UNIT_MB)
 #define GF_MIN_SOCKET_WINDOW_SIZE (0)
